var $$ = function( sid ) { return document.getElementById( sid ); };
var colorFlag;
function toggleColorList() {
	var list = $$( "colorList" );
	if( list.style.display == "none" ) {
		list.innerHTML = '';
		list.style.display = "block";
		var cfName = "cf" + new Date().getTime();
		list.innerHTML = '<iframe id=' + cfName + ' name=' + cfName + ' style="width:50px;height:272px" frameborder=0></iframe>';
		window.frames[ cfName ].document.write( colorFrameStr );
		window.frames[ cfName ].document.close();
		colorFlag = "front";
	} else {
		list.innerHTML = '';
		list.style.display = "none";
	}
}
function toggleBGColorList() {
	var list = $$( "bgColorList" );
	if( list.style.display == "none" ) {
		list.innerHTML = '';
		list.style.display = "block";
		var cfName = "cf" + new Date().getTime();
		list.innerHTML = '<iframe id=' + cfName + ' name=' + cfName + ' style="width:50px;height:272px" frameborder=0></iframe>';
		window.frames[ cfName ].document.write( colorFrameStr );
		window.frames[ cfName ].document.close();
		colorFlag = "back";
	} else {
		list.innerHTML = '';
		list.style.display = "none";
	}
}
function colorSelected( colorCell ) {
	var color = colorCell.attributes.getNamedItem( "value" ).value;
	if (colorFlag == "front") {
		$$( "colorField" ).style.backgroundColor = color;
		$$( "colorList" ).style.display = "none";
		$$( "sampleText" ).style.color = color;
		$$( "colorList" ).innerHTML = '';
	} else {
		$$( "bgColorField" ).style.backgroundColor = color;
		$$( "bgColorList" ).style.display = "none";
		$$( "sampleText" ).style.backgroundColor = color;
		$$( "bgColorList" ).innerHTML = '';
	}
}
function toggleFontBold() {
	var cell = $$( "fontBold" );
	if( cell.value == "0" || cell.value == null ) {
		cell.value = "1";
		cell.style.backgroundColor = "#9966FF";
		$$( "sampleText" ).style.fontWeight = "bold";
	}
	else {
		cell.value = "0";
		cell.style.backgroundColor = "#c0c0c0";
		//alert($$( "sampleText" ).innerHTML)
		$$( "sampleText" ).style.fontWeight = "normal";
	}
}

function toggleFontItalic() {
	var cell = $$( "fontItalic" );
	if( cell.value == "0" || cell.value == null ) {
		cell.value = "1";
		cell.style.backgroundColor = "#9966FF";
		$$( "sampleText" ).style.fontStyle = "italic";
	}
	else {
		cell.value = "0";
		cell.style.backgroundColor = "#c0c0c0";
		$$( "sampleText" ).style.fontStyle = "normal";
	}
}
function toggleFontUnderline() {
	var cell = $$( "fontUnderline" );
	if( cell.value == "0" || cell.value == null ) {
		cell.value = "1";
		cell.style.backgroundColor = "#9966FF";
		$$( "sampleText" ).style.textDecoration = "underline";
	}
	else {
		cell.value = "0";
		cell.style.backgroundColor = "#c0c0c0";
		$$( "sampleText" ).style.textDecoration = "none";
	}
}

function setAlign( cell ) {
	var alignLeft = $$( "alignLeft" );
	var alignCenter = $$( "alignCenter" );
	var alignRight = $$( "alignRight" );
	var align = "left";
	if( !cell || cell.id == "alignLeft" ) {
		alignLeft.style.backgroundColor = "#9966FF";
		alignCenter.style.backgroundColor = "#c0c0c0";
		alignRight.style.backgroundColor = "#c0c0c0";
		align = "left";
	}
	else if( cell.id == "alignCenter" ) {
		alignLeft.style.backgroundColor = "#c0c0c0";
		alignCenter.style.backgroundColor = "#9966FF";
		alignRight.style.backgroundColor = "#c0c0c0";
		align = "center";
	}
	else if( cell.id == "alignRight" ) {
		alignLeft.style.backgroundColor = "#c0c0c0";
		alignCenter.style.backgroundColor = "#c0c0c0";
		alignRight.style.backgroundColor = "#9966FF";
		align = "right";
	}
	$$( "sampleText" ).style.textAlign = align;
}
var shuzhi = [ "#0.00","#.00","#.#","#0.000","#.000","#,##0.00","#,###.00","#,###.#","#,##0.000","#,###.000" ];
var huobi = [ "#0.00","#.00","#.#","#0.000","#.000","#,##0.00","#,###.00","#,###.#","#,##0.000","#,###.000","$#0.00","$#.00","$#.#","$#0.000","$#.000","$#,##0.00","$#,###.00","$#,###.#","$#,##0.000","$#,###.000" ];
var riqi = [ "yyyy-MM-dd","yyyyMMdd","yyyy/MM/dd","yy-MM-dd","yyMMdd","yy/MM/dd" ];
var shijian = [ "HH:mm:ss","HH:mm:ssS","kk:mm:ss","kk:mm:ssS","hh:mm:ss","hh:mm:ssS","KK:mm:ss","KK:mm:ssS" ];
var rqsj = [ "yyyy-MM-dd HH:mm:ss","yyyyMMdd HH:mm:ss","yyyy/MM/dd HH:mm:ss","yy-MM-dd HH:mm:ss","yyMMdd HH:mm:ss","yy/MM/dd HH:mm:ss" ];
var fenshu = [ "#0.00%","#.00%","#.#%","#0.000%","#.000%","#,##0.00%","#,###.00%","#,###.#%","#,##0.000%","#,###.000%" ];
var kexue = [ "0.#E0","0.##E0","0.###E0","00.#E0","00.##E0","00.###E0","##0.#E0","##0.##E0","##0.###E0" ];
function changeFormatList( fmt ) {
	var list = shuzhi;
	switch( fmt ) {
		case "0": list = shuzhi; break;
		case "1": list = huobi; break;
		case "2": list = riqi; break;
		case "3": list = shijian; break;
		case "4": list = rqsj; break;
		case "5": list = fenshu; break;
		case "6": list = kexue; break;
	}
	var listBox = $$( "formatList" );
	listBox.options.length = 0;
	for( var i = 0; i< list.length; i++ ) {
		listBox.options.add( new Option( list[i], list[i], false, false ), listBox.options.length );
	}
}

var colorFrameStr = '<body topMargin=0 leftMargin=0 rightMargin=0 bottomMargin=0 style="overflow:hidden">' +
	'<table width=48 cellpadding=3 style="background-color:white">' +
	'<tr height=16><td style="background-color:#FF0000" value="#FF0000" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#FFFF00" value="#FFFF00" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#00FF00" value="#00FF00" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#00FFFF" value="#00FFFF" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#0000FF" value="#0000FF" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#FF00FF" value="#FF00FF" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#808080" value="#808080" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#800000" value="#800000" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#808000" value="#808000" onclick="parent.colorSelected(this)"></td></tr>' + 
	'<tr height=16><td style="background-color:#008000" value="#008000" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#008080" value="#008080" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#000080" value="#000080" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#800080" value="#800080" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#000000" value="#000000" onclick="parent.colorSelected(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#FFFFFF;font-size:12px;" value="#FFFFFF" onclick="parent.colorSelected(this)">&nbsp;&nbsp;ɫ</td></tr>' +
	'</table></body>';

var setStyleCallBack = null;
function initCellStyle( cell, format, callBack, zoom ) {
	setStyleCallBack = callBack;
	if (rqBrowser.FF) cell.currentStyle = window.getComputedStyle(cell, null);
	var font = cell.currentStyle.fontFamily;
	var txt = $$( "sampleText" );
	$$( "fontList" ).value = font;
	txt.style.fontFamily = font;
	var size = cell.currentStyle.fontSize;
	$$( "fontSizeList" ).value = size;
	txt.style.fontSize = size;
	var color = cell.currentStyle.color;
	$$( "colorField" ).style.backgroundColor = color;
	txt.style.color = color;
	var bgColor = cell.currentStyle.backgroundColor;
	if (selectTdBakColor != null) bgColor = selectTdBakColor;
	$$( "bgColorField" ).style.backgroundColor = bgColor;
	txt.style.backgroundColor = bgColor;
	var b = cell.currentStyle.fontWeight;
	txt.style.fontWeight = b;
	var fb = $$( "fontBold" );
	if( b == 700 || b == "bold" ) {
		fb.value = "1";
		fb.style.backgroundColor = "#9966FF";
	}
	else {
		fb.value = "0";
		fb.style.backgroundColor = "#c0c0c0";
	}
	var italic = cell.currentStyle.fontStyle;
	if( italic == null ) italic = "normal";
	txt.style.fontStyle = italic;
	var fi = $$( "fontItalic" );
	if( italic.toLowerCase() == "italic" ) {
		fi.value = "1";
		fi.style.backgroundColor = "#9966FF";
	}
	else {
		fi.value = "0";
		fi.style.backgroundColor = "#c0c0c0";
	}
	var under = cell.currentStyle.textDecoration;
	if( under == null ) under = "none";
	txt.style.textDecoration = under;
	var fu = $$( "fontUnderline" );
	if( under.toLowerCase() == "underline" ) {
		fu.value = "1";
		fu.style.backgroundColor = "#9966FF";
	}
	else {
		fu.value = "0";
		fu.style.backgroundColor = "#c0c0c0";
	}
	var align = cell.currentStyle.textAlign;
	if( align == null ) align = "left";
	align = align.toLowerCase();
	var alignCell = null;
	
	if( align == "left" || align == "" ) alignCell = $$( "alignLeft" );
	else if( align == "center" ) alignCell = $$( "alignCenter" );
	else if( align == "right" ) alignCell = $$( "alignRight" );
	setAlign( alignCell );
	$$( "formatBox" ).value = (format==null || format=="null")?"":format;
	$$( "zoomBox" ).value = (zoom==null || zoom=="null")?"1.0":zoom;
}
function getCellStyle() {
	var txt = $$( "sampleText" );
	if (rqBrowser.FF) txt.currentStyle = txt.style;
	var s = txt.currentStyle.fontFamily + "|";
	var size = txt.currentStyle.fontSize;
	//alert(txt.currentStyle.color);
	var color = new RGBColor(txt.currentStyle.color);
	s += size.substring( 0, size.length - 2 ) + "|" + color.toHex().substring( 1 ) + "|";
	if( txt.currentStyle.fontWeight == 700 ) s += "1|";
	else s += "0|";
	if( txt.currentStyle.fontStyle.toLowerCase() == "italic" ) s += "1|";
	else s += "0|";
	if( txt.currentStyle.textDecoration.toLowerCase() == "underline" ) s += "1|";
	else s += "0|";
	var align = txt.currentStyle.textAlign.toLowerCase();
	if( align == "left" ) s += "0|";
	else if( align == "center" ) s += "1|";
	else if( align == "right" ) s += "2|";
	s += $$( "formatBox" ).value + "|";
	s += $$( "zoomBox" ).value + "|";
	var bc = txt.currentStyle.backgroundColor;
	if (bc == null || bc == "" || bc == "transparent") bc = "#ffffff";
	var bgColor = new RGBColor(bc);
	s += bgColor.toHex().substring( 1 );
	setStyleCallBack(s);
	$('#styleDialog').dialog('close');
	return s;
}


//===========================condition appearance==========================================
var condAppearCallback;
function initExps(exps, params, callback){
	while ($$('expTable').rows.length > 1) $$('expTable').deleteRow(1);
	if (exps != null) {
		exps = exps.split(";");
		var conds = exps[0].split(",");
		defltAppearance = exps[1].split('<p>');
		for (var i=0; i<conds.length; i++) {
			if (conds[i].indexOf("<p>") >= 0) {
				addExp(conds[i]);
			}
		}
	}
	var params = params.split(",");
	var html = "ò<a href='#' style='text-decoration:none;border-bottom:1px solid #2569AB;'>ǰֵ(x)</a>";
	for (var i=0; i<params.length; i++) {
		if (i == 3 || i == 7) html += "<br>";
		else html += "&nbsp;&nbsp;";
		html += "<a href='#' style='text-decoration:none;border-bottom:1px solid #2569AB;'>" + params[i] + "</a>"; 
	}
	$$('expParams').innerHTML = html;
	condAppearCallback = callback;
}

var defltAppearance;
function addExp(cond){
	var exp = "";
	if (cond != null && cond != 'null') {
		cond = cond.split(':');
		exp = cond[0];
		cond = cond[1].split("<p>");
	} else {
		cond = new Array();	
	}
	if (cond[0] == null) cond[0] = defltAppearance[0];
	if (cond[1] == null) cond[1] = defltAppearance[1];
	if (cond[2] == null) cond[2] = defltAppearance[2];
	if (cond[3] == null) cond[3] = defltAppearance[3];
	if (cond[4] == null) cond[4] = defltAppearance[4];
	if (cond[5] == null) cond[5] = defltAppearance[5];
	
	var tr = $$('expTable').insertRow(-1);
	
	var td = tr.insertCell(-1);
	td.innerHTML = '<input type="text" style="width:97%;" value="' + exp + '">';
//	td.style.height = '30px';
//	td.style.width = '50px';

	td = tr.insertCell(-1);
	td.innerHTML = '<select onchange="fontChange(this)" style="width:100%"><option value=""></option><option value=""></option><option value="_GB2312">_GB2312</option><option value="_GB2312">_GB2312</option><option value=""></option><option value="Բ">Բ</option><option value=""></option><option value="Ŀ">Ŀ</option><option value="п">п</option><option value="Arial">Arial</option><option value="Dialog">Dialog</option><option value="System">System</option><option value="Times New Roman">Times New Roman</option></select>';
	td.childNodes[0].value = cond[0];

	td = tr.insertCell(-1);
	td.innerHTML = '<img onclick="boldChange(this)" style="background-color:' + ("1"==cond[1]?"#9966FF":"#c0c0c0") + '" src="' + contextPath + '/dm/images/font_bold.gif" border=no><img onclick="italicChange(this)" style="background-color:' + ("1"==cond[2]?"#9966FF":"#c0c0c0") + '" src="' + contextPath + '/dm/images/font_italic.gif" border=no><img onclick="underlineChange(this)" style="background-color:' + ("1"==cond[3]?"#9966FF":"#c0c0c0") + '" src="' + contextPath + '/dm/images/font_underline.gif" border=no>';
	td.childNodes[0].value = ("1"==cond[1]?1:0);
	td.childNodes[1].value = ("1"==cond[2]?1:0);
	td.childNodes[2].value = ("1"==cond[3]?1:0);
	
	td = tr.insertCell(-1);
//	cond[4] = parseInt(cond[4]);
	var r = ((cond[4] >> 16) & 0xFF).toString(16);
	var g = ((cond[4] >> 8) & 0xFF).toString(16);
	var b = (cond[4] & 0xFF).toString(16);
	cond[4] = "#" + (r.length==1?"0"+r:r) + (g.length==1?"0"+g:g) + (b.length==1?"0"+b:b);
	td.innerHTML = '<input type=text readonly onclick="colorListSelect(this)" style="width:35px;height:14px;border-right:none;background-color:' + cond[4] + ';"><img src="' + contextPath + '/dm/images/dropdown.jpg" border=no onclick="colorListSelect(this)" style="vertical-align:bottom">';

	td = tr.insertCell(-1);
	r = ((cond[5] >> 16) & 0xFF).toString(16);
	g = ((cond[5] >> 8) & 0xFF).toString(16);
	b = (cond[5] & 0xFF).toString(16);
	cond[5] = "#" + (r.length==1?"0"+r:r) + (g.length==1?"0"+g:g) + (b.length==1?"0"+b:b);
	td.innerHTML = '<input type=text readonly onclick="colorListSelect(this)" style="width:35px;height:14px;border-right:none;background-color:' + cond[5] + ';"><img src="' + contextPath + '/dm/images/dropdown.jpg" border=no onclick="colorListSelect(this)" style="vertical-align:bottom">';
	
	td = tr.insertCell(-1);
	td.innerHTML = 'ʾ';
	td.style.fontFamily = cond[0];
	td.style.fontWeight = cond[1]=="1"?"bold":"normal";
	td.style.fontStyle = cond[2]=="1"?"italic":"normal";
	td.style.textDecoration = cond[3]=="1"?"underline":"none";
	td.style.color = cond[4];
	td.style.backgroundColor = cond[5];
	
	
	td = tr.insertCell(-1);
	td.innerHTML = '<a href="javascript:void(0);" onclick="this.parentNode.parentNode.parentNode.removeChild(this.parentNode.parentNode);" style="color:red">ɾ</a>';
	td.align = 'center';

}

function submitExps(){
	var rows = $$("expTable").rows;
	var exps = "";
	for (var i=1; i<rows.length; i++) {
		var row = rows[i];
		var exp = jQuery.trim(row.childNodes[0].childNodes[0].value);
		if (exp == "") {
			alert("ʽΪգ");
			return;
		}
		if (exps != "") exps += ",";
		exps += exp + ":";
		exps += row.childNodes[1].childNodes[0].value + "<p>";
		exps += row.childNodes[2].childNodes[0].value + "<p>";
		exps += row.childNodes[2].childNodes[1].value + "<p>";
		exps += row.childNodes[2].childNodes[2].value + "<p>";
		var color = new RGBColor(row.childNodes[3].childNodes[0].style.backgroundColor);
		exps += (color.b | (color.g << 8) | (color.r << 16) | (0xFF << 24)) + "<p>";
		color = new RGBColor(row.childNodes[4].childNodes[0].style.backgroundColor);
		exps += color.b | (color.g << 8) | (color.r << 16) | (0xFF << 24);
	}
	
	$('#expsDialog').dialog('close');
	condAppearCallback(exps);
}

var currColorBox = null;
function colorListSelect(src) {
	if (src.tagName.toLowerCase() == 'img') src = src.parentNode.childNodes[0];
	currColorBox = src;
	var pos = getRealPos(src);
	var list = $$( "colorListDiv" );
	list.style.top = pos[0] - $$("expTable").offsetParent.offsetTop + 20 + 'px';
	list.style.left = pos[1] - $$("expTable").offsetParent.offsetLeft + 'px';
	if( list.style.display == "none" ) {
		list.innerHTML = '';
		list.style.display = "block";
		var cfName = "cf" + new Date().getTime();
		list.innerHTML = '<iframe id=' + cfName + ' name=' + cfName + ' style="width:50px;height:272px" frameborder=0></iframe>';
		window.frames[ cfName ].document.write( colorFrameStr4Cond );
		window.frames[ cfName ].document.close();
	} else {
		list.innerHTML = '';
		list.style.display = "none";
	}
}
function colorChange( colorCell ) {
	var color = colorCell.attributes.getNamedItem( "value" ).value;
	currColorBox.style.backgroundColor = color;
	if (currColorBox.parentNode.parentNode.childNodes[3] == currColorBox.parentNode) {
		currColorBox.parentNode.parentNode.childNodes[5].style.color = color;
	} else {
		currColorBox.parentNode.parentNode.childNodes[5].style.backgroundColor = color;
	}
//	$$( "sampleText" ).style.color = color;
	$$( "colorListDiv" ).style.display = "none";
	$$( "colorListDiv" ).innerHTML = '';
}

var colorFrameStr4Cond = '<body topMargin=0 leftMargin=0 rightMargin=0 bottomMargin=0 style="overflow:hidden">' +
	'<table width=48 cellpadding=3 style="background-color:white">' +
	'<tr height=16><td style="background-color:#FF0000" value="#FF0000" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#FFFF00" value="#FFFF00" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#00FF00" value="#00FF00" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#00FFFF" value="#00FFFF" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#0000FF" value="#0000FF" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#FF00FF" value="#FF00FF" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#808080" value="#808080" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#800000" value="#800000" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#808000" value="#808000" onclick="parent.colorChange(this)"></td></tr>' + 
	'<tr height=16><td style="background-color:#008000" value="#008000" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#008080" value="#008080" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#000080" value="#000080" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#800080" value="#800080" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#000000" value="#000000" onclick="parent.colorChange(this)"></td></tr>' +
	'<tr height=16><td style="background-color:#FFFFFF;font-size:12px;" value="#FFFFFF" onclick="parent.colorChange(this)">&nbsp;&nbsp;ɫ</td></tr>' +
	'</table></body>';

function fontChange(src){
	var value = src.value;
	var sample = src.parentNode.parentNode.childNodes[5];
	sample.style.fontFamily = value;
}

function boldChange(src){
	if( src.value == "0" || src.value == null ) {
		src.value = "1";
		src.style.backgroundColor = "#9966FF";
		src.parentNode.parentNode.childNodes[5].style.fontWeight = "bold";
	}
	else {
		src.value = "0";
		src.style.backgroundColor = "#c0c0c0";
		src.parentNode.parentNode.childNodes[5].style.fontWeight = "normal";
	}
}

function italicChange(src){
	if( src.value == "0" || src.value == null ) {
		src.value = "1";
		src.style.backgroundColor = "#9966FF";
		src.parentNode.parentNode.childNodes[5].style.fontStyle = "italic";
	}
	else {
		src.value = "0";
		src.style.backgroundColor = "#c0c0c0";
		src.parentNode.parentNode.childNodes[5].style.fontStyle = "normal";
	}
}

function underlineChange(src){
	if( src.value == "0" || src.value == null ) {
		src.value = "1";
		src.style.backgroundColor = "#9966FF";
		src.parentNode.parentNode.childNodes[5].style.textDecoration = "underline";
	}
	else {
		src.value = "0";
		src.style.backgroundColor = "#c0c0c0";
		src.parentNode.parentNode.childNodes[5].style.textDecoration = "none";
	}
}




